#ifndef _FAULT_H_
#define _FAULT_H_
#include <asm/score_expt.h>

#define check_pa_err_part_bit(pa_err, FUNC) \
    __check_part_bit(pa_err, PA_ERR_##FUNC##_M)
enum PA_ERR {
    REG_BITMAP(PA_ERR, SPC, 0, 16)
    REG_BITMAP(PA_ERR, PAIU, 16, 4)
    REG_BITMAP(PA_ERR, RIU, 20, 2)
    REG_BITMAP(PA_ERR, SRI, 22, 2)
    REG_BITMAP(PA_ERR, PAMU, 24, 1)
};

#define check_pa_rerr_part_bit(pa_rerr, FUNC) \
    __check_part_bit(pa_rerr, PA_RERR_##FUNC##_M)
enum PA_RERR {
    REG_BITMAP(PA_RERR, SPC, 0, 16)
    REG_BITMAP(PA_RERR, PAIU, 16, 4)
    REG_BITMAP(PA_RERR, RIU, 20, 2)
    REG_BITMAP(PA_RERR, SRI, 22, 2)
    REG_BITMAP(PA_RERR, PAMU, 24, 1)
};

#define check_pa_fault_part_bit(pa_fault, FUNC) \
    __check_part_bit(pa_fault, PA_FAULT_##FUNC##_M)
enum PA_FAULT {
    REG_BITMAP(PA_FAULT, SPC, 0, 16)
    REG_BITMAP(PA_FAULT, PAIU, 16, 4)
    REG_BITMAP(PA_FAULT, RIU, 20, 2)
    REG_BITMAP(PA_FAULT, SRI, 22, 2)
    REG_BITMAP(PA_FAULT, PAMU, 24, 1)
};

#define check_pa_warn_part_bit(pa_warn, FUNC) \
    __check_part_bit(pa_warn, PA_WARN_##FUNC##_M)
enum PA_WARN {
    REG_BITMAP(PA_WARN, SPC, 0, 16)
    REG_BITMAP(PA_WARN, PAIU, 16, 4)
    REG_BITMAP(PA_WARN, RIU, 20, 2)
    REG_BITMAP(PA_WARN, SRI, 22, 2)
    REG_BITMAP(PA_WARN, PAMU, 24, 1)
};

#define check_cg_fault_stat_part_bit(cg_fault_stat, FUNC) \
	__check_part_bit(cg_fault_stat, CG_FAULT_STAT_##FUNC##_M)
enum CG_FAULT_STAT {
	REG_BITMAP(CG_FAULT_STAT, MPE_FAULTS, 0, 5)
	REG_BITMAP(CG_FAULT_STAT, MPE_MCHK, 0, 1)
	REG_BITMAP(CG_FAULT_STAT, MPE_SINGLE, 1, 1)
	REG_BITMAP(CG_FAULT_STAT, MPE_DOUBLE, 2, 1)
	REG_BITMAP(CG_FAULT_STAT, MPE_SOFT_FAULT, 3, 1)
	REG_BITMAP(CG_FAULT_STAT, MPE_SOFT_ERR, 4, 1)

	REG_BITMAP(CG_FAULT_STAT, SPE_FAULTS, 5, 5)
	REG_BITMAP(CG_FAULT_STAT, SPE_UNREC, 5, 1)
	REG_BITMAP(CG_FAULT_STAT, SPE_REC, 6, 1)
	REG_BITMAP(CG_FAULT_STAT, SPE_EXCEP, 7, 1)
	REG_BITMAP(CG_FAULT_STAT, SPE_WARN, 8, 1)
	REG_BITMAP(CG_FAULT_STAT, SPE_FAULT, 9, 1)

	REG_BITMAP(CG_FAULT_STAT, PM_FAULTS, 10, 5)
	REG_BITMAP(CG_FAULT_STAT, PM_UNREC, 10, 1)
	REG_BITMAP(CG_FAULT_STAT, PM_REC, 11, 1)
	REG_BITMAP(CG_FAULT_STAT, PM_EXCEP, 12, 1)
	REG_BITMAP(CG_FAULT_STAT, PM_WARN, 13, 1)
	REG_BITMAP(CG_FAULT_STAT, PM_FAULT, 14, 1)
};


#define check_si_fault_stat_part_bit(si_fault_stat, FUNC) \
	__check_part_bit(si_fault_stat, SI_FAULT_STAT_##FUNC##_M)
enum SI_FAULT_STAT {
	REG_BITMAP(SI_FAULT_STAT, MCUERRS, 0, 4)
	REG_BITMAP(SI_FAULT_STAT, MCU_SOFT_ERR, 0, 1)
	REG_BITMAP(SI_FAULT_STAT, MCU_CTRL_ERR, 1, 1)
	REG_BITMAP(SI_FAULT_STAT, MCU_UNREC, 2, 1)
	REG_BITMAP(SI_FAULT_STAT, MCU_REC, 3, 1)

	REG_BITMAP(SI_FAULT_STAT, PIU0ERRS, 4, 4)
	REG_BITMAP(SI_FAULT_STAT, PIU0_SOFT_ERR, 4, 1)
	REG_BITMAP(SI_FAULT_STAT, PIU0_CTRL_ERR, 5, 1)
	REG_BITMAP(SI_FAULT_STAT, PIU0_UNREC, 6, 1)
	REG_BITMAP(SI_FAULT_STAT, PIU0_REC, 7, 1)

	REG_BITMAP(SI_FAULT_STAT, PIU1ERRS, 8, 4)
	REG_BITMAP(SI_FAULT_STAT, PIU1_SOFT_ERR, 8, 1)
	REG_BITMAP(SI_FAULT_STAT, PIU1_CTRL_ERR, 9, 1)
	REG_BITMAP(SI_FAULT_STAT, PIU1_UNREC, 10, 1)
	REG_BITMAP(SI_FAULT_STAT, PIU1_REC, 11, 1)

	REG_BITMAP(SI_FAULT_STAT, EIUERRS, 12, 4)
	REG_BITMAP(SI_FAULT_STAT, EIU_SOFT_ERR, 12, 1)
	REG_BITMAP(SI_FAULT_STAT, EIU_CTRL_ERR, 13, 1)
	REG_BITMAP(SI_FAULT_STAT, EIU_UNREC, 14, 1)
	REG_BITMAP(SI_FAULT_STAT, EIU_REC, 15, 1)

	REG_BITMAP(SI_FAULT_STAT, IRU0ERRS, 17, 3)
	REG_BITMAP(SI_FAULT_STAT, IRU0_CTRL_ERR, 17, 1)
	REG_BITMAP(SI_FAULT_STAT, IRU0_UNREC, 18, 1)
	REG_BITMAP(SI_FAULT_STAT, IRU0_REC, 19, 1)

	REG_BITMAP(SI_FAULT_STAT, IRU1ERRS, 21, 3)
	REG_BITMAP(SI_FAULT_STAT, IRU1_CTRL_ERR, 21, 1)
	REG_BITMAP(SI_FAULT_STAT, IRU1_UNREC, 22, 1)
	REG_BITMAP(SI_FAULT_STAT, IRU1_REC, 23, 1)

	REG_BITMAP(SI_FAULT_STAT, INTPUERRS, 24, 4)
	REG_BITMAP(SI_FAULT_STAT, INTPU_SOFT_ERR, 24, 1)
	REG_BITMAP(SI_FAULT_STAT, INTPU_CTRL_ERR, 25, 1)
	REG_BITMAP(SI_FAULT_STAT, INTPU_UNREC, 26, 1)
	REG_BITMAP(SI_FAULT_STAT, INTPU_REC, 27, 1)

	REG_BITMAP(SI_FAULT_STAT, INTERRS, 28, 4)
	REG_BITMAP(SI_FAULT_STAT, INT_MT_INT_MISS, 28, 1)
	REG_BITMAP(SI_FAULT_STAT, INT_UNMASK_INT_MISS, 29, 1)
	REG_BITMAP(SI_FAULT_STAT, INT_IIC_INT, 30, 1)

	REG_BITMAP(SI_FAULT_STAT, LINKFAULTS, 32, 4)
	REG_BITMAP(SI_FAULT_STAT, PIU0_PCIE_LINKDOWN, 32, 1)
	REG_BITMAP(SI_FAULT_STAT, PIU1_PCIE_LINKDOWN, 33, 1)

    REG_BITMAP(SI_FAULT_STAT, MTCERRS, 36, 5)
    REG_BITMAP(SI_FAULT_STAT, MTC_UNREC, 36, 1)
    REG_BITMAP(SI_FAULT_STAT, MTC_REC, 37, 1)
    REG_BITMAP(SI_FAULT_STAT, MTC_EXCEP, 38, 1)
    REG_BITMAP(SI_FAULT_STAT, MTC_WARN, 39, 1)
    REG_BITMAP(SI_FAULT_STAT, MTC_FAULT, 40, 1)

    REG_BITMAP(SI_FAULT_STAT, ENV_ALARM, 41, 2)
};

#define pa_online MCU_READ_REG(PA_ONLINE)

#define for_each_online_pa(i) \
    for (i = 0; i < NR_SCORE_ARRAY_NUM; i++) \
	if ((pa_online >> i) & 0x1)

#endif
