/*
 * SICH Bridge Related Definitions
 */

#ifndef _SW_SICH_H_
#define _SW_SICH_H_

/* Device switches based on AMBA bridge of SICH */
enum MSISWCfgBase_OF_SICH {
	PS2KB_OF_SICH   = 0x004,
	PS2MO_OF_SICH   = 0x008,
	UART_OF_SICH    = 0x00c,
	GPIO_OF_SICH    = 0x010,
	LPC_OF_SICH     = 0x014,
	XCHI_OF_SICH    = 0x018,
	I2C0_OF_SICH    = 0x01c,
	I2C2_OF_SICH    = 0x024,
	GMAC0_OF_SICH   = 0x028,
	GMAC1_OF_SICH   = 0x02c,
	SATA_OF_SICH    = 0x030,
	GPU_OF_SICH     = 0x034,
	VPU_OF_SICH     = 0x038,
	DC_OF_SICH      = 0x03c,
	DMA_OF_SICH     = 0x040,
	AC97_OF_SICH    = 0x044,
	I2C1_OF_SICH    = 0x048,
	SPI_OF_SICH     = 0x04c,
};

extern unsigned long swich_bridge_addr;
extern unsigned long swich_spi_addr;

extern int bios_9230_disable, bios_ich2sata_disable;
extern int bios_7340_disable, bios_ich2xhci_disable;
extern int bios_i350_disable;

extern int no_sich;
extern int sich_i2c_devinit(void);

#endif	/* _SW_SICH_H */
